package nc.bs.yp.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.servlet.service.BaseServlet;
import nc.itf.so.m4331.IDeliveryAssitFunc;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.log.NcLog;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.pub.BusinessException;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.pubapp.pattern.model.transfer.bill.ClientBillCombinServer;
import nc.vo.so.m4331.entity.DeliveryVO;
import nc.vo.so.pub.SOParameterVO;
import net.sf.json.JSONObject;

public class DeliveryCloseImpl extends BaseServlet implements IHttpServletAdaptor{
	
	IUAPQueryBS iuap= (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	IMDPersistenceQueryService service = NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
	String pk_group = "";

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		// TODO Auto-generated method stub
		pk_group = this.qryGroup();
		InvocationInfoProxy.getInstance().setGroupId(pk_group);
		NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(),"pfxx".getBytes());
		String createStr = buildJson(req, resp, this.getClass().getName());
		JSONObject json = JSONObject.fromObject(createStr);
		String vbillcode = "";
		Object cdeliveryid = null;
		PrintWriter out = resp.getWriter();
		vbillcode = json.getString("vbillcode");
		try {
			checkJson(json);
			String qrysql = "select cdeliveryid from so_delivery where nvl(dr,0)=0 and vbillcode = '"+vbillcode+"'";
			cdeliveryid = iuap.executeQuery(qrysql, new ColumnProcessor());
			if(cdeliveryid != null) {
				DeliveryVO deliveryvo = (DeliveryVO) service.queryBillOfNCObjectByPK(DeliveryVO.class,cdeliveryid.toString()).getContainmentObject();
				DeliveryVO[] bills = new DeliveryVO[1];
				bills[0] = deliveryvo;
				DeliveryVO[] ret = null;
				ret = this.getServcie().closeDelivery(bills);
				resp.getWriter().write(formatRSJsonData("0",
						vbillcode,"").toString());
			}
			else {
				resp.getWriter().write(formatRSJsonData("1",
						vbillcode,"鲻÷").toString());
				NcLog.info("鲻÷:"+vbillcode);
			}
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			resp.getWriter().write(formatRSJsonData("1",
					vbillcode,e.getMessage().toString()).toString());
			StringWriter stringWriter = new StringWriter();
			e.printStackTrace(new PrintWriter(stringWriter));
			//ȡϸϢ
			String msg=stringWriter.getBuffer().toString();
			NcLog.info("ӿڷֵʾ:"+msg);
		}
		
	}

	private IDeliveryAssitFunc getServcie() {
	    return NCLocator.getInstance().lookup(IDeliveryAssitFunc.class);
	  }
	
	/**
	 * ǿж
	 * @param json
	 * @throws Exception
	 */
	private void checkJson(JSONObject json) throws Exception {
		
		StringBuffer mags = new StringBuffer();
		Boolean empty = true;
		
		String vbillcode = "vbillcode";//ݺ
		
		String[] HeadKey = {vbillcode};
		
		for (String as : HeadKey) {

			if (json.getString(as).isEmpty()) {
				empty = false;
				mags.append("'" + as + "'");
			}
		}
		
		if (!empty) {
			throw new Exception("ֶβΪգ"+mags);
		}
	}
	
	/**
	 * ȡid
	 * @return
	 */
	private String qryGroup() {
		String qrysql = "select pk_group from org_group where nvl(dr,0)=0 and rownum = 1";
		String pk_group;
		try {
			pk_group = (String) iuap.executeQuery(qrysql, new ColumnProcessor());
			return pk_group;
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
}
